import logging
from clirch import language, utils, lookup, pruning

loglevel = logging.DEBUG
languages = [language.norwegian, language.spanish]
logfile = 'debug.log'
pipeline_overrides = {
    language.norwegian: {
        language.spanish: [
            utils.force_unicode,
            utils.mtag,
            utils.get_stopword_filtrer('Norwegian'),
            lookup.pickled.PickledDict('no', 'es'),
            pruning.reduce_options_by_group(0, 1),
        ]
    },
    language.spanish: {
        language.norwegian: [
            utils.force_unicode,
            utils.treetag,
            utils.get_stopword_filtrer('Spanish'),
            lookup.wordnet_es.SpanishWordnetSynonyms(),
            lookup.pickled.PickledDict('es', 'no'),
            pruning.reduce_options_by_group(0, 3),
        ]
    }
}
