import logging

from clirch import language, utils, lookup, pruning

loglevel = logging.INFO
languages = [language.norwegian, language.spanish]
pipeline_overrides = {
    language.norwegian: {
        language.spanish: [
            utils.force_unicode,
            utils.get_regexp_tokenizer(),
            utils.get_stopword_filtrer('Norwegian'),
            lookup.pickled.PickledDict('no', 'es'),
            lookup.wordnet_es.SpanishWordnetSynonyms(),
            pruning.reduce_options_by_group(0, 1),
        ]
    },
    language.spanish: {
        language.norwegian: [
            utils.force_unicode,
            utils.get_regexp_tokenizer(),
            utils.get_stopword_filtrer('Spanish'),
            lookup.wordnet_es.SpanishWordnetSynonyms(),
            lookup.pickled.PickledDict('es', 'no'),
            pruning.reduce_options_by_group(0, 1),
        ]
    }
}
