#!/usr/bin/env python
# encoding: utf-8

import sys

import tritrans

LANGS = set(['en', 'es', 'no'])
TT = {
        'en': {
            'no': tritrans.Tritrans('en', 'no', False),
            'es': tritrans.Tritrans('en', 'es', False),
            },
        'es': {
            'en': tritrans.Tritrans('es', 'en', False),
            'no': tritrans.Tritrans('es', 'no', False),
            },
        'no': {
            'en': tritrans.Tritrans('no', 'en', False),
            'es': tritrans.Tritrans('no', 'es', False),
            },
        }

def recursive_lookup(words, passes=1000):
    done = 0
    while (passes != done) and words:
        word, language = words.pop(0)
        print word, language
        targets = LANGS - set([language])
        if tritrans._cache[language][iter(targets).next()].isleaf(word):
            continue
        for target in targets:
            for translation in TT[language][target]([word]):
                translation = list(translation)
                print ' ', translation, target
                for part in translation:
                    words.append((part, target))
        done += 1
    if done > 0:
        tritrans.save_cache()

if __name__ == '__main__':
    try:
        passes = int(sys.argv[1])
        sys.argv.pop(1)
    except ValueError:
        passes = 1000
    except IndexError:
        print 'Please supply keywords for translation/lookup/caching'
    recursive_lookup([(word, 'en') for word in sys.argv[1:]], passes)
