#!/usr/bin/env python
# encoding: utf-8

import logging
import time

logging.basicConfig(level=logging.DEBUG)

from clirch.utils import force_unicode
import tritrans

tritrans.PICKLE_FILE = '/home/xim/tmp/tritrans.pickle'

tritrans.load_cache()

lang_codes = ['en', 'es', 'no']

if __name__ == '__main__':

    try:
        for lang_code in lang_codes:
            save_count = 0
            with open('wordlist.' + lang_code) as words:
                for word in words:
                    word = force_unicode(word.strip())
                    if not word:
                        continue

                    logging.debug('%s: %s' % (lang_code, word))
                    exists = False
                    for key, dictionary in tritrans._cache[lang_code].iteritems():
                        if dictionary.isleaf(word):
                            exists = True
                    if exists:
                        logging.info('Word exists: "%s"' % word)
                        continue

                    try:
                        tritrans.tritrans(lang_code, word, False)
                    except Exception, ex:
                        logging.error(ex.__class__.__name__ + ': ' + str(ex))
                    for key, dictionary in tritrans._cache[lang_code].iteritems():
                        if not dictionary.isleaf(word):
                            logging.error('"%s" not found in %s -> %s' % (word, lang_code, key))
                    logging.debug('Sleeping 5 sec')
                    time.sleep(5)
                    save_count += 1
                    if not save_count % 1000:
                        logging.info('SAVING CACHE')
                        tritrans.save_cache()

    except KeyboardInterrupt:
        pass
    else:
        logging.info('DONE')

    logging.info('SAVING CACHE')
    tritrans.save_cache()
