class WrappedTransformedWord(unicode):
    weight = None
    origins = None

    def __add__(self, other):
        return TransformedWord(super(WrappedTransformedWord,
            self).__add__(other), self.origins, self.weight)

    def __getitem__(self, index):
        return TransformedWord(super(WrappedTransformedWord,
            self).__getitem__(index), self.origins, self.weight)

    def __getslice__(self, pos1, pos2):
        return TransformedWord(super(WrappedTransformedWord,
            self).__getslice__(pos1, pos2), self.origins, self.weight)

    def __repr__(self):
        return 't' + super(WrappedTransformedWord, self).__repr__()[1:]

def TransformedWord(word, origin=None, weight=None, **kwargs):
    word = WrappedTransformedWord(word, **kwargs)

    if word.origins is None:
        word.origins = []
    if word.weight is None:
        word.weight = 1.0

    if hasattr(origin, '__iter__'):
        word.origins += list(origin)
    else:
        word.origins += list(getattr(origin, 'origins', []))
        word.origins.append(unicode(origin))

    if hasattr(origin, 'weight'):
        word.weight *= origin.weight

    if weight:
        word.weight *= weight

    return word
